(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('chart.js'), require('randomcolor'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@biosoftcl/chart-js-module', ['exports', '@angular/core', 'chart.js', 'randomcolor', '@angular/common'], factory) :
    (factory((global.biosoftcl = global.biosoftcl || {}, global.biosoftcl['chart-js-module'] = {}),global.ng.core,global.chart_js,global.randomColor,global.ng.common));
}(this, (function (exports,core,chart_js,randomColor,common) { 'use strict';

    randomColor = randomColor && randomColor.hasOwnProperty('default') ? randomColor['default'] : randomColor;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartJsComponent = /** @class */ (function () {
        function ChartJsComponent() {
            this.chart = null;
        }
        /**
         * @return {?}
         */
        ChartJsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.ctx = this.canvasRef.nativeElement.getContext('2d');
                switch (this.type) {
                    case 'chart.pie': {
                        this.createChartPie();
                        break;
                    }
                    case 'chart.bar': {
                        this.createChartBar();
                        break;
                    }
                    case 'chart.column': {
                        this.createChartColumn();
                        break;
                    }
                    default: {
                        console.warn('Chart couldn\'t be generated');
                        break;
                    }
                }
                this.updateChart.subscribe(( /**
                 * @return {?}
                 */function () {
                }));
            };
        /**
         * @return {?}
         */
        ChartJsComponent.prototype.createChartPie = /**
         * @return {?}
         */
            function () {
                this.chart = new chart_js.Chart(this.ctx, {
                    type: 'pie',
                    data: {
                        labels: this.data.labels,
                        datasets: [{
                                label: this.data.series,
                                data: this.data.data,
                                backgroundColor: this.dynamicColors(),
                            }]
                    },
                    responsive: true,
                    maintainAspectRatio: false
                });
            };
        /**
         * @return {?}
         */
        ChartJsComponent.prototype.createChartBar = /**
         * @return {?}
         */
            function () {
                this.chart = new chart_js.Chart(this.ctx, {
                    type: 'horizontalBar',
                    data: {
                        labels: this.data.labels,
                        datasets: [{
                                label: this.data.series,
                                data: this.data.data,
                                backgroundColor: this.dynamicColors(),
                            }]
                    },
                    responsive: true,
                    maintainAspectRatio: false
                });
            };
        /**
         * @return {?}
         */
        ChartJsComponent.prototype.createChartColumn = /**
         * @return {?}
         */
            function () {
                this.chart = new chart_js.Chart(this.ctx, {
                    type: 'bar',
                    data: {
                        labels: this.data.labels,
                        datasets: [{
                                label: this.data.series,
                                data: this.data.data,
                                backgroundColor: this.dynamicColors(),
                            }]
                    },
                    responsive: true,
                    maintainAspectRatio: false
                });
            };
        /**
         * @return {?}
         */
        ChartJsComponent.prototype.dynamicColors = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var color = randomColor({
                    count: this.data.data.length + 1,
                    format: 'rgb',
                    luminosity: 'light',
                    hue: 'random',
                });
                return color;
            };
        ChartJsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'chartjs-chart',
                        template: "<div class=\"chart-container\">\n    <canvas #canvas>{{chart}}</canvas>\n</div>\n",
                        styles: [".chart-container{max-width:100%!important;overflow-y:auto}.chart-container canvas{max-height:100%;max-width:100%}"]
                    }] }
        ];
        /** @nocollapse */
        ChartJsComponent.ctorParameters = function () { return []; };
        ChartJsComponent.propDecorators = {
            type: [{ type: core.Input }],
            data: [{ type: core.Input }],
            label: [{ type: core.Input }],
            updateChart: [{ type: core.Input }],
            canvasRef: [{ type: core.ViewChild, args: ['canvas',] }]
        };
        return ChartJsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartJsModule = /** @class */ (function () {
        function ChartJsModule() {
        }
        ChartJsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [
                            ChartJsComponent
                        ],
                        providers: [],
                        exports: [
                            ChartJsComponent
                        ]
                    },] }
        ];
        return ChartJsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ChartJsModule = ChartJsModule;
    exports.ChartJsComponent = ChartJsComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=biosoftcl-chart-js-module.umd.js.map